import javax.swing.*;
import java.awt.*;

public class MainFrame extends JFrame {

    private CardLayout cardLayout;
    private JPanel mainPanel;
    int localMult;

    public MainFrame() {
        setTitle("Studium Versenken");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setSize(1500, 1000);
        setLocationRelativeTo(null);

        //JLabel backgroundLabel = new JLabel(new ImageIcon("graphics/mainmenubackground.png"));
       // backgroundLabel.setBounds(0, 0, 1500, 1000);
      //  getContentPane().add(backgroundLabel);

       // backgroundLabel.setOpaque(true);

        // CardLayout und Hauptpanel erstellen
        cardLayout = new CardLayout();
        mainPanel = new JPanel(cardLayout);

        // Verschiedene Panels erstellen und hinzufügen
        MainMenuView mainMenuView = new MainMenuView(this);
        startLocalGame localGame = new startLocalGame(this);
        startMultiplayerGame multiplayerGame = new startMultiplayerGame(this);
        coinToss coinToss = new coinToss(this);
        //JoinGame joinGame = new JoinGame(this,localMult);

        mainPanel.add(mainMenuView, "MainMenu");
        mainPanel.add(localGame, "LocalGame");
        mainPanel.add(multiplayerGame, "MultiplayerGame");
        mainPanel.add(coinToss, "coinToss");
        //mainPanel.add(joinGame, "JoinGame");
        // Hauptpanel in JFrame hinzufügen
        add(mainPanel);

        // Hauptmenü anzeigen
        cardLayout.show(mainPanel, "MainMenu");
    }

    // Methode, um die Ansicht zu wechseln
    public void showPanel(String panelName) {
        cardLayout.show(mainPanel, panelName);
    }

    public void showPanelExtra(String panelName,int num) {
        this.localMult = num;

        if (!isPanelPresent(panelName)) {
            JoinGame joinGame = new JoinGame(this, localMult);
            mainPanel.add(joinGame, panelName); // Dynamically add the panel
            mainPanel.revalidate(); // Refresh the layout
            mainPanel.repaint();
        }

        cardLayout.show(mainPanel, panelName); // Show the panel
    }
    private boolean isPanelPresent(String panelName) {
        for (Component component : mainPanel.getComponents()) {
            if (panelName.equals(mainPanel.getClientProperty("name"))) {
                return true;
            }
        }
        return false;
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(() -> {
            MainFrame frame = new MainFrame();
            frame.setVisible(true);
        });
    }
}